<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <NuxtLayout name="default">
        <div class="catalog-page">

            <!-- sidebar navigation teleported to template -->
            <SidebarNav :nav="navItems" :title="'Glossary'" />

            <!-- <FiltersTop :sortOptions="sortOptions">
                <a href="#" class="button-secondary orange" title="Add">New Term</a>
                <a href="#" class="button-simple" title="Add">Import Term</a>
                <div class="filters-top-totals"><b>1211 Terms</b> available</div>
            </FiltersTop> -->

            <Datatable :data="data">
                <button class="button-secondary orange" @click="showCreateTermModal = true">New Term</button>
                <div class="filters-top-totals"><b>{{ termsLength }} Terms</b> available</div>
            </Datatable>

            <div class="container">
                <div class="offset-xl-1 col-xl-10 mt-160">
                    <BannersBannerCta :banners="BannerCta" />
                </div>
            </div>

            <ClientOnly>
                <Teleport to="#modals-container">
                    <ModalsCreateTerm v-if="showCreateTermModal" @toggle="close" />
                </Teleport>
            </ClientOnly>

        </div>
    </NuxtLayout>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import type NavItemI from '~/interfaces/navItem';
import type sliderItemI from '~/interfaces/sliderItem';
import slide1 from '@/assets/images/slide1.png';
import { formatDate, removeHtmlTags } from '~/utils/utils';
import { navigateTo } from 'nuxt/app';

useHead({
    title: 'Catalog - DATAMITE'
});

/** GLOSSARY - fetch data from api **/

interface Glossary {
    id: number;
    name: string;
    type: string;
    group: string;
    domains: any;
    description: string;
    updatedAt: string;
    createdAt: string;
    terms: any
}

let termsLength = 0;

const showCreateTermModal = ref(false);

const close = () => {
	showCreateTermModal.value = false;
};

const aux: any = [];

useFetchAuth('/glossaries')
    .then(async (response: any) => {
        const glossary: Glossary[] = response;

        // Map the response data to match the structure of `rows`
        const rows = glossary.map((term: Glossary, index: number) => ({
            id: term.id,
            name: term.name,
            type: 'Term'
        }));

        // Map all terms to `rows`
        glossary.forEach((term: any) => {
            for (let i = 0; i < term.terms.length; i++) {
                termsLength++;
                data.value.rows?.push({
                    id: term.terms[i].id,
                    name: term.terms[i].name,
                    type: 'Term',
                });
            }
        });
    })
    .catch(error => {
        console.error('API Error:', error);
    });

const data = ref<DataTableI>({
    options: {
        tableName: 'glossary-table',
        detailsPath: '/glossary/terms/',
        allowCheckRow: true,
        favourites: true,
        previewComponent: 'GlossaryDetails',
    },
    columns: [
        {
            id: 1,
            name: 'name',
            label: 'Name',
            combineColumn: 'type',
            renderComponent: 'TableColumnsName',
            width: '200px'
        }
    ],
    rows: []
});

const viewDefault = () => {
    console.log('show default home page');
}

const dummyClick = () => {
    console.log('dummyClick');
}

const goToGlossary = () => {
    navigateTo('/glossary');
}

const goToAllTerms = () => {
    navigateTo('/glossary/terms');
}

const navItems = ref<NavItemI[]>([
    {
        label: 'Glossary',
        icon: 'vocabularies_nav',
        action: goToGlossary,
    }, {
        label: 'All terms',
        icon: 'clock',
        action: goToAllTerms,
        active: true
    },
    {
        label: 'Recently viewed',
        icon: 'clock',
        action: dummyClick
    },
    {
        label: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Your Catalog',
        icon: 'loading',
        action: dummyClick
    }
]);

const sortOptions = ref(['Last modified first', 'Last modified last', 'Option 3']);


const BannerCta = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'Have a question or doubts?',
        text: 'Check our FAQs and Documentation',
        button_text: 'Faqs and Documentation',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    }
])

</script>